--[[	PhantomPlates Dispatcher Library
	by SDPhantom
	https://www.wowinterface.com/forums/member.php?u=34145
	https://www.curseforge.com/members/sdphantomgamer/projects	]]
--------------------------------------------------------------------------

--------------------------
--[[	Namespace	]]
--------------------------
local AddOn=select(2,...);
--AddOn.Dispatcher={};

----------------------------------
--[[	Dispatcher Metatable	]]
----------------------------------
local DispatcherMeta={__index={}};

local DispatcherEnclosures=setmetatable({},{
	__mode="k";
	__index=function(t,k)
		local function dispatcher(...) return k(...); end
		t[k]=dispatcher; return dispatcher;
	end;
});

function DispatcherMeta.__index:AddCallback(func)
	if not tContains(self,func) then table.insert(self,func); end
end

function DispatcherMeta.__index:RemoveCallback(func)
	local index=tIndexOf(self,func);
	if index then table.remove(self,index); end
end

function DispatcherMeta.__index:WipeCallbacks() return table.wipe(self); end

function DispatcherMeta.__index:FireCallbacks(...)
	local errhnd=geterrorhandler();
	for _,func in ipairs(self) do xpcall(func,errhnd,...); end
end

function DispatcherMeta.__index:EncloseDispatcher() return DispatcherEnclosures[self]; end

DispatcherMeta.__call=DispatcherMeta.__index.FireCallbacks;

----------------------------------
--[[	Dispatcher Objects	]]
----------------------------------
function AddOn.CreateDispatcher() return setmetatable({},DispatcherMeta); end
